package controleurs;


import vue.Fenetre;
import info1.ships.*;
import vue.Case;
import vue.FenetrePlateau;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;

public class ControleurPlacerBateauSelectionne implements ActionListener {

    private Fenetre fenetre;
    private NavyFleet fleet;
    private static int compteurTorpilleur = 0;
    private static int compteurCroiseur = 0;
    private static int compteurCuirasse = 0;
    private static int compteurSousMarin = 0;

    public ControleurPlacerBateauSelectionne(Fenetre fen, NavyFleet nv){
        this.fenetre = fen;
        this.fleet = nv;
    }


    @Override
    public void actionPerformed(ActionEvent e) {
        boolean ok = true;//Pas élégant mais sert à éviter la boucle infinie
            //Vérification que les champs sont biens complets
            if (fenetre.getCoordFront().equals("") || fenetre.getCoordBack().equals("")) {
                JFrame erreur = new JFrame();
                JOptionPane.showMessageDialog(erreur, "Veuillez remplir les deux champs afin d'ajouter un bateau !", "Erreur", JOptionPane.WARNING_MESSAGE);
                ok = false;
            }

        if(ok == true){ //Evite d'avoir les deux messages d'erreur en même temps lorsque le champ est vide
            try {
                Coord testCoordFront = new Coord(fenetre.getCoordFront()); //Récupération des coordonnées
                Coord testCoordBack = new Coord(fenetre.getCoordBack()); //Récupération des coordonnées

                ok = true;

                //Tests qui évitent un bug, il faut rentrer les coordonées dans l'odre croissant pour pouvoir
                //Exemple : il faut rentrer A1 C1 et pas C1 A1 || A3 A5 et pas A5 A3
                if(testCoordFront.getX() == testCoordBack.getX()){ //Si X sont égaux
                    if(testCoordBack.getY() < testCoordFront.getY()){
                        JFrame erreur = new JFrame();
                        JOptionPane.showMessageDialog(erreur, "Veuillez rentrez les coordonnées dans l'ordre \"croissant\"", "Erreur", JOptionPane.WARNING_MESSAGE);
                        ok = false; //Sans le ok, le bateau était quand même placé
                    }
                }
                else if(testCoordFront.getY() == testCoordBack.getY()){ //Si Y sont égaux
                    if(testCoordFront.getX() > testCoordBack.getX()){
                        JFrame erreur = new JFrame();
                        JOptionPane.showMessageDialog(erreur, "Veuillez rentrez les coordonnées dans l'ordre \"croissant\"", "Erreur", JOptionPane.WARNING_MESSAGE);
                        ok = false; //Sans le ok, le bateau était quand même placé
                    }
                }


                if(ok == true){ //Quand ok est true on peut rentrer dans la phase "placer le bateau"
                    switch(fenetre.getCategorieBateauAPlacer()){ //En fonction du cgoix de la combo-box
                        case "Sous-marin (1 case)":
                            //On teste si les coordonnées entrées correspondent bien à un bateau de taille 1 (sous marin)
                            if((Math.abs(testCoordFront.getX() - testCoordBack.getX() + 1) == 1) && (Math.abs(testCoordFront.getY() - testCoordBack.getY() + 1) == 1 ) ) {
                                Submarine sousmarin = new Submarine("sous-marin"+String.valueOf(compteurSousMarin), testCoordFront.toString()); //On crée le bateau
                                if(fleet.add(sousmarin) == -3){ //Si le bateau empiète sur un bateau déjà placé
                                    JFrame erreur = new JFrame();
                                    JOptionPane.showMessageDialog(erreur, "Impossible de placer ce bateau : il utilise les mêmes coordonnées qu'un autre bateau déjà placé", "Erreur", JOptionPane.WARNING_MESSAGE);
                                    break; //On sort du switch, le bateau n'est pas placé
                                }
                                else{
                                    fleet.add(sousmarin); //Ajout du bateau dans la flotte
                                    //Il faut maintenant le placer sur la grille
                                    //Recherche de la case :
                                    Case caseTrouvee = fenetre.getPlateauPers().getCase(testCoordFront.getY() - 1, testCoordFront.getX() - 1);
                                    caseTrouvee.setColor(new Color(106, 255, 189)); //On change la couleur de la case pour indiquer que le bateau est placé dessus
                                    compteurSousMarin++; //On incrémente le compteur qui permet de donner un nom différent à chaque bateau créé de cette catégorie

                                    fenetre.supprimerChoixBateauCourant(); //Supprimer le choix de la combobox
                                }

                            }
                            else{
                                JFrame erreur = new JFrame();
                                JOptionPane.showMessageDialog(erreur, "Coordonnées incorrectes pour un sous-marin (taille 1)", "Erreur", JOptionPane.WARNING_MESSAGE);
                            }
                            break;
                        //Le principe de fonctionnement d'ajout des autres bateaux est le même que pour le sous marin, à part qu'une boucle
                        //se charge de remplir toutes les cases prises par le bateau
                        case "Torpilleur (2 cases)":
                            //On vérifie la taille du bateau
                            if((Math.abs(testCoordFront.getX() - testCoordBack.getX() + 2) == 2) || (Math.abs(testCoordFront.getY() - testCoordBack.getY() + 2) == 2 ) ) {
                                Destroyer torpilleur = new Destroyer("destroyer"+String.valueOf(compteurTorpilleur)+"", testCoordFront.toString(), testCoordBack.toString());
                                if(fleet.add(torpilleur) == -3){
                                    JFrame erreur = new JFrame();
                                    JOptionPane.showMessageDialog(erreur, "Impossible de placer ce bateau : il utilise les mêmes coordonnées qu'un autre bateau déjà placé", "Erreur", JOptionPane.WARNING_MESSAGE);
                                    break;
                                }
                                else{
                                    fleet.add(torpilleur); //Ajout du bateau dans la flotte
                                    //Il faut maintenant le placer sur la grille
                                    //Recherche des cases et coloration:
                                    if(testCoordFront.getX() == testCoordBack.getX()){
                                        for(int i = 0; i < torpilleur.getSize(); i++){
                                            Case caseTrouvee = fenetre.getPlateauPers().getCase(testCoordFront.getY() - 1 + i, testCoordFront.getX() - 1);
                                            caseTrouvee.setColor(new Color(106, 226, 255));
                                        }
                                    }
                                    else{
                                        for(int i = 0; i < torpilleur.getSize(); i++){
                                            Case caseTrouvee = fenetre.getPlateauPers().getCase(testCoordFront.getY() - 1, testCoordFront.getX() - 1 + i );
                                            caseTrouvee.setColor(new Color(106, 226, 255));
                                        }
                                    }
                                    fenetre.supprimerChoixBateauCourant(); //Supprimer le choix de la combobox
                                    compteurTorpilleur++;
                                    break;
                                }

                            }
                            else{
                                JFrame erreur = new JFrame();
                                JOptionPane.showMessageDialog(erreur, "Coordonnées incorrectes pour un torpilleur (taille 2)", "Erreur", JOptionPane.WARNING_MESSAGE);
                            }

                        case "Croiseur (3 cases)":
                            //On vérifie la taille du bateau
                            if((Math.abs(testCoordFront.getX() - testCoordBack.getX() + 3) == 3) || (Math.abs(testCoordFront.getY() - testCoordBack.getY() + 3) == 3) ) {
                                Cruiser croiseur = new Cruiser("cruiser"+String.valueOf(compteurCroiseur)+"", testCoordFront.toString(), testCoordBack.toString());
                                if(fleet.add(croiseur) == -3){
                                    JFrame erreur = new JFrame();
                                    JOptionPane.showMessageDialog(erreur, "Impossible de placer ce bateau : il utilise les mêmes coordonnées qu'un autre bateau déjà placé", "Erreur", JOptionPane.WARNING_MESSAGE);
                                    break;
                                }
                                else{
                                    fleet.add(croiseur); //Ajout du bateau dans la flotte
                                    //Il faut maintenant le placer sur la grille
                                    //Recherche des cases et coloration:
                                    if(testCoordFront.getX() == testCoordBack.getX()){
                                        for(int i = 0; i < croiseur.getSize(); i++){
                                            Case caseTrouvee = fenetre.getPlateauPers().getCase(testCoordFront.getY() - 1 + i, testCoordFront.getX() - 1);
                                            caseTrouvee.setColor(new Color(106, 153, 255));
                                        }
                                    }
                                    else{
                                        for(int i = 0; i < croiseur.getSize(); i++){
                                            Case caseTrouvee = fenetre.getPlateauPers().getCase(testCoordFront.getY() - 1, testCoordFront.getX() - 1 + i );
                                            caseTrouvee.setColor(new Color(106, 153, 255));
                                        }
                                    }
                                    fenetre.supprimerChoixBateauCourant(); //Supprimer le choix de la combobox
                                    compteurCroiseur++;
                                    break;
                                }

                            }
                            else{
                                JFrame erreur = new JFrame();
                                JOptionPane.showMessageDialog(erreur, "Coordonnées incorrectes pour un croiseur (taille 3)", "Erreur", JOptionPane.WARNING_MESSAGE);
                            }
                        case "Cuirassé (4 cases)":
                            //On vérifie la taille du bateau
                            if((Math.abs(testCoordFront.getX() - testCoordBack.getX() + 4) == 4) || (Math.abs(testCoordFront.getY() - testCoordBack.getY() + 4) == 4) ) {
                                Battleship cuirasse = new Battleship("cuirasse"+String.valueOf(compteurCuirasse)+"", testCoordFront.toString(), testCoordBack.toString());
                                if(fleet.add(cuirasse) == -3){
                                    JFrame erreur = new JFrame();
                                    JOptionPane.showMessageDialog(erreur, "Impossible de placer ce bateau : il utilise les mêmes coordonnées qu'un autre bateau déjà placé", "Erreur", JOptionPane.WARNING_MESSAGE);
                                    break;
                                }
                                else{
                                    fleet.add(cuirasse); //Ajout du bateau dans la flotte
                                    //Il faut maintenant le placer sur la grille
                                    //Recherche des cases et coloration:
                                    if(testCoordFront.getX() == testCoordBack.getX()){
                                        for(int i = 0; i < cuirasse.getSize(); i++){
                                            Case caseTrouvee = fenetre.getPlateauPers().getCase(testCoordFront.getY() - 1 + i, testCoordFront.getX() - 1);
                                            caseTrouvee.setColor(new Color(255, 106, 158));
                                        }
                                    }
                                    else{
                                        for(int i = 0; i < cuirasse.getSize(); i++){
                                            Case caseTrouvee = fenetre.getPlateauPers().getCase(testCoordFront.getY() - 1, testCoordFront.getX() - 1 + i );
                                            caseTrouvee.setColor(new Color(255, 106, 158));
                                        }
                                    }
                                    fenetre.supprimerChoixBateauCourant(); //Supprimer le choix de la combobox
                                    compteurCuirasse++;
                                    break;
                                }

                            }
                            else{
                                JFrame erreur = new JFrame();
                                JOptionPane.showMessageDialog(erreur, "Coordonnées incorrectes pour un cuirassé (taille 4)", "Erreur", JOptionPane.WARNING_MESSAGE);
                            }
                        case "Porte-avion (5 cases)":
                            if((Math.abs(testCoordFront.getX() - testCoordBack.getX() + 5) == 5) || (Math.abs(testCoordFront.getY() - testCoordBack.getY() + 5) == 5) ) {
                                AircraftCarrier porteAvion = new AircraftCarrier("porte-avion", testCoordFront.toString(), testCoordBack.toString());
                                if(fleet.add(porteAvion) == -3){
                                    JFrame erreur = new JFrame();
                                    JOptionPane.showMessageDialog(erreur, "Impossible de placer ce bateau : il utilise les mêmes coordonnées qu'un autre bateau déjà placé", "Erreur", JOptionPane.WARNING_MESSAGE);
                                    break;
                                }
                                else{
                                    fleet.add(porteAvion); //Ajout du bateau dans la flotte
                                    //Il faut maintenant le placer sur la grille
                                    //Recherche de la case :
                                    if(testCoordFront.getX() == testCoordBack.getX()){
                                        for(int i = 0; i < porteAvion.getSize(); i++){
                                            Case caseTrouvee = fenetre.getPlateauPers().getCase(testCoordFront.getY() - 1 + i, testCoordFront.getX() - 1);
                                            caseTrouvee.setColor(new Color(255, 178, 106));
                                        }
                                    }
                                    else{
                                        for(int i = 0; i < porteAvion.getSize(); i++){
                                            Case caseTrouvee = fenetre.getPlateauPers().getCase(testCoordFront.getY() - 1, testCoordFront.getX() - 1 + i );
                                            caseTrouvee.setColor(new Color(255, 178, 106));
                                        }
                                    }

                                    fenetre.supprimerChoixBateauCourant(); //Supprimer le choix de la combobox
                                }

                            }
                            else{
                                JFrame erreur = new JFrame();
                                JOptionPane.showMessageDialog(erreur, "Coordonnées incorrectes pour un porte-avion (taille 5)", "Erreur", JOptionPane.WARNING_MESSAGE);
                            }
                            break;

                    }
                    fenetre.setEnableChoixModeJeu(false);
                    //Quand la JComboBox est vide, c'est à dire que tous les bateaux ont été placés
                    if(fenetre.getCategorieBateauAPlacer() == null){
                        fenetre.setEnableCreer(true); //On active les boutons qui permettent de créer ou rejoindre une partie
                        fenetre.setEnableRejoindre(true);
                    }
                }

            } catch (BadCoordException | CoordsBadShipException badCoordException) {
                JFrame erreur = new JFrame();
                JOptionPane.showMessageDialog(erreur, "Veuillez réessayer avec des coordonnées correctes", "Erreur", JOptionPane.WARNING_MESSAGE);
            }









        }






    }
}
