package controleurs;


import com.mashape.unirest.http.exceptions.UnirestException;
import info1.network.Game;
import info1.network.Network;
import info1.network.Player;
import info1.ships.BadCoordException;
import info1.ships.Coord;
import info1.ships.INavyFleet;
import info1.ships.NavyFleet;
import vue.*;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.IOException;
import java.util.ArrayList;

import javax.sound.sampled.*;
import java.io.File;
import java.io.IOException;

import static vue.FenetrePlateau.etatTour;

public class ControleurPlateauDroite implements ActionListener {

    private FenetrePlateau fenetrePlateau;
    private Fenetre fenetre;
    public  String HTTP_LOCALHOST;
    public  Player joueur1;
    public  INavyFleet flotte1;
    public Game partie = null;
    private boolean pcIut;
    private int aMoiJouer;

    public ControleurPlateauDroite(FenetrePlateau fen , Fenetre fleet,boolean pc){
        this.fenetrePlateau = fen;
        this.fenetre = fleet;
        this.joueur1 = fleet.getJoueur1();
        this.flotte1 = fleet.getFlotte1();
        this.HTTP_LOCALHOST = fleet.getNetwork();
        this.partie = fleet.getGame();
        this.pcIut = pc;
    }

    @Override
    public void actionPerformed(ActionEvent e) {




        ArrayList<CaseBouton> listeCoordBoutons = fenetrePlateau.getPlateauAdversaire().getListeCasesBoutons();//On récupère la liste de toutes les CaseBouton du panneau
        int buttonIndex = listeCoordBoutons.indexOf(e.getSource()); //On recherche dans la liste l'emplacement de la case cliquée
        CaseBouton caseCliquee = listeCoordBoutons.get(buttonIndex); //Une fois trouvé l'emplacement; on récupère la case
        //lecture d'un fichier audio lors d'un click sur un bouton:
        if(this.pcIut != true) {
            try {
                File file = new File("./Media/Sound/click.wav");//recup le fichier audio
                AudioInputStream audioStream = AudioSystem.getAudioInputStream(file);//convertie le fichier fichier en audio utilisable par la classe clip
                Clip clip = AudioSystem.getClip();//Attribue le fichier audio
                clip.open(audioStream);//ajoute a la liste de lecture
                FloatControl gainControl = (FloatControl) clip.getControl(FloatControl.Type.MASTER_GAIN);// recup le volume du clip
                // edit le volume du clip (entre 0.0 et 1.0)
                double gain = 0.65;
                float dB = (float) (Math.log(gain) / Math.log(10.0) * 20.0);// convertie en decibel le double
                gainControl.setValue(dB);//modifie le volume
                clip.start(); //lance le fichier audio
            } catch (UnsupportedAudioFileException unsupportedAudioFileException) {
                unsupportedAudioFileException.printStackTrace();
            } catch (LineUnavailableException lineUnavailableException) {
                lineUnavailableException.printStackTrace();
            } catch (IOException ioException) {
                ioException.printStackTrace();
            }
        }


        //Récupération de la Coord de la case cliquée :
        try {
            //Récupération de la Coord de la case cliquée :
            Coord coordonneeCaseClique = new Coord(""+(char)(caseCliquee.getCoordX() + 64)+""+caseCliquee.getCoordY()); // récupère les coordonnée de la case cliquer
            int info = Network.getInfo(HTTP_LOCALHOST, partie, joueur1); // 1= partie ok(créer) /-1=partie ok autre joueur(rejoindre) /10= a toi de jouer /-10= pas a toi de jouer /100= tu a gagner /-100 tu a perdu /-9999=sinon

            if(info == (-100)){ // test lorsque qu'un bouton est appuyer si la partie est perdu avant d'éxecuter la suite
                if(this.pcIut != true) {
                    try {//audio de défaite
                        File file = new File("./Media/Sound/music_defaite.wav");//recup le fichier audio
                        File file2 = new File("./Media/Sound/parole_perdu2.wav");//recup le fichier audio
                        AudioInputStream audioStream = AudioSystem.getAudioInputStream(file);//convertie le fichier fichier en audio utilisable par la classe clip
                        AudioInputStream audioStream2 = AudioSystem.getAudioInputStream(file2);//convertie le fichier fichier en audio utilisable par la classe clip
                        Clip clip = AudioSystem.getClip();//Attribue le fichier audio
                        Clip clip2 = AudioSystem.getClip();//Attribue le fichier audio
                        clip.open(audioStream);//ajoute a la liste de lecture
                        clip2.open((audioStream2));//ajoute a la liste de lecture
                        FloatControl gainControl = (FloatControl) clip.getControl(FloatControl.Type.MASTER_GAIN);// recup le volume du clip
                        FloatControl gainControl2 = (FloatControl) clip2.getControl(FloatControl.Type.MASTER_GAIN);// recup le volume du clip
                        // edit le volume du clip (entre 0.0 et 1.0)
                        double gain = 0.45;
                        float dB = (float) (Math.log(gain) / Math.log(10.0) * 20.0);// convertie en decibel le double
                        gainControl.setValue(dB);//modifie le volume
                        gainControl2.setValue(dB);//modifie le volume
                        clip.start(); //lance le fichier audio
                        clip2.start(); //lance le fichier audio
                        JOptionPane.showMessageDialog(fenetre, "Perdu ! Tu es mauvais Jack !", "Resultat", JOptionPane.PLAIN_MESSAGE); //affiche un pop up
                        clip.stop();
                        clip2.stop();
                    } catch (UnsupportedAudioFileException unsupportedAudioFileException) {
                        unsupportedAudioFileException.printStackTrace();
                    } catch (LineUnavailableException lineUnavailableException) {
                        lineUnavailableException.printStackTrace();
                    } catch (IOException ioException) {
                        ioException.printStackTrace();
                    }
                }else{
                    JOptionPane.showMessageDialog(fenetre, "Perdu ! Tu es mauvais Jack !", "Résultat", JOptionPane.PLAIN_MESSAGE); //affiche un pop up
                }


                //ferme la page et renvoie sur celle du créer flotte et rejoindre/créer une partie:
                fenetrePlateau.dispose();// ferme cette fenêtre
                Plateau plateauPers = new Plateau(); //créer le plateau pour placer sa flotte
                Fenetre placerBateau = new Fenetre(plateauPers);//créer la fenêtre de start
                NavyFleet navyFleet = new NavyFleet();//créer la flotte (est vide)
                placerBateau.FixedListenerCommencerUnPartie(new StartPartie(placerBateau,navyFleet));//Listener bouton créer
                placerBateau.FixedListenerRejoindreUnePartie(new RejoindrePartie(placerBateau,navyFleet)); //Listener bouton rejoindre
                placerBateau.fixeListenerAjoutBateau(new ControleurPlacerBateauSelectionne(placerBateau,navyFleet)); //Listener ajouter placement bateau
                placerBateau.fixeListenerRemplissageCategorie(new ControleurListeAjoutBateau(placerBateau, navyFleet)); //Ajouter bateaux en fonction du mode de jeu
                placerBateau.pack();//permet de faire prendre au éléments leurs preffered size
                placerBateau.setVisible(true);// active la fenetre(permet de l'afficher)

            }
            if(info == (10)){ // test si a toi de jouer
                int res = Network.playOneTurn(HTTP_LOCALHOST, partie, joueur1, new Coord(coordonneeCaseClique.toString())); //-10= pas à toi de jouer /0= pas toucher /1= tu a toucher /10= tu à couler un navire /100= tu a gagner
                if(res == 0){ //cas: on a rien toucher
                    caseCliquee.setEnabled(false); //désactive la case
                    caseCliquee.setBackground(Color.LIGHT_GRAY);// met la case en gris
                    if(this.pcIut != true) {
                        try {//audio pour rien toucher
                            File file = new File("./Media/Sound/plouf.wav");//recup le fichier audio
                            AudioInputStream audioStream = AudioSystem.getAudioInputStream(file);//convertie le fichier fichier en audio utilisable par la classe clip
                            Clip clip = AudioSystem.getClip();//Attribue le fichier audio
                            clip.open(audioStream);//ajoute a la liste de lecture
                            FloatControl gainControl = (FloatControl) clip.getControl(FloatControl.Type.MASTER_GAIN);// recup le volume du clip
                            // edit le volume du clip (entre 0.0 et 1.0)
                            double gain = 0.65;
                            float dB = (float) (Math.log(gain) / Math.log(10.0) * 20.0);// convertie en decibel le double
                            gainControl.setValue(dB);//modifie le volume
                            clip.start(); //lance le fichier audio
                        } catch (UnsupportedAudioFileException unsupportedAudioFileException) {
                            unsupportedAudioFileException.printStackTrace();
                        } catch (LineUnavailableException lineUnavailableException) {
                            lineUnavailableException.printStackTrace();
                        } catch (IOException ioException) {
                            ioException.printStackTrace();
                        }
                    }
                }
                if(res == 1){//cas: on a toucher un navire
                    caseCliquee.setEnabled(false); //désactive la case
                    caseCliquee.setBackground(Color.red);// met la case en rouge
                    if(this.pcIut != true) {
                        try {//audio pour toucher un navire
                            File file = new File("./Media/Sound/explosion_little.wav");//recup le fichier audio
                            AudioInputStream audioStream = AudioSystem.getAudioInputStream(file);//convertie le fichier fichier en audio utilisable par la classe clip
                            Clip clip = AudioSystem.getClip();//Attribue le fichier audio
                            clip.open(audioStream);//ajoute a la liste de lecture
                            FloatControl gainControl = (FloatControl) clip.getControl(FloatControl.Type.MASTER_GAIN);// recup le volume du clip
                            // edit le volume du clip (entre 0.0 et 1.0)
                            double gain = 0.65;
                            float dB = (float) (Math.log(gain) / Math.log(10.0) * 20.0);// convertie en decibel le double
                            gainControl.setValue(dB);//modifie le volume
                            clip.start(); //lance le fichier audio
                        } catch (UnsupportedAudioFileException unsupportedAudioFileException) {
                            unsupportedAudioFileException.printStackTrace();
                        } catch (LineUnavailableException lineUnavailableException) {
                            lineUnavailableException.printStackTrace();
                        } catch (IOException ioException) {
                            ioException.printStackTrace();
                        }
                    }
                }
                if(res == 10){//cas: on a couler un navire
                    caseCliquee.setEnabled(false); //désactive la case
                    caseCliquee.setBackground(Color.BLUE);// met la case en rouge
                    JOptionPane.showMessageDialog(fenetre,"Vous avez coulé un navire ! Bien joué !","Résultat",JOptionPane.PLAIN_MESSAGE); //affiche un pop up
                    if(this.pcIut != true) {
                        try {//audio pour couler un navire
                            File file = new File("./Media/Sound/explosion_big.wav");//recup le fichier audio
                            AudioInputStream audioStream = AudioSystem.getAudioInputStream(file);//convertie le fichier fichier en audio utilisable par la classe clip
                            Clip clip = AudioSystem.getClip();//Attribue le fichier audio
                            clip.open(audioStream);//ajoute a la liste de lecture
                            FloatControl gainControl = (FloatControl) clip.getControl(FloatControl.Type.MASTER_GAIN);// recup le volume du clip
                            // edit le volume du clip (entre 0.0 et 1.0)
                            double gain = 0.65;
                            float dB = (float) (Math.log(gain) / Math.log(10.0) * 20.0);// convertie en decibel le double
                            gainControl.setValue(dB);//modifie le volume
                            clip.start(); //lance le fichier audio
                        } catch (UnsupportedAudioFileException unsupportedAudioFileException) {
                            unsupportedAudioFileException.printStackTrace();
                        } catch (LineUnavailableException lineUnavailableException) {
                            lineUnavailableException.printStackTrace();
                        } catch (IOException ioException) {
                            ioException.printStackTrace();
                        }
                    }
                }
                if(res == 100){//cas: on a couler le dernier navire donc victoire
                    caseCliquee.setEnabled(false); //désactive la case
                    caseCliquee.setBackground(Color.red);// met la case en rouge
                    if(this.pcIut != true) {
                        try {//audio de victoire
                            File file = new File("./Media/Sound/music_victoire.wav");//recup le fichier audio
                            File file2 = new File("./Media/Sound/parole_victoire.wav");//recup le fichier audio
                            AudioInputStream audioStream = AudioSystem.getAudioInputStream(file);//convertie le fichier fichier en audio utilisable par la classe clip
                            AudioInputStream audioStream2 = AudioSystem.getAudioInputStream(file2);//convertie le fichier fichier en audio utilisable par la classe clip
                            Clip clip = AudioSystem.getClip();//Attribue le fichier audio
                            Clip clip2 = AudioSystem.getClip();//Attribue le fichier audio
                            clip.open(audioStream);//ajoute a la liste de lecture
                            clip2.open((audioStream2));//ajoute a la liste de lecture
                            FloatControl gainControl = (FloatControl) clip.getControl(FloatControl.Type.MASTER_GAIN);// recup le volume du clip
                            FloatControl gainControl2 = (FloatControl) clip2.getControl(FloatControl.Type.MASTER_GAIN);// recup le volume du clip
                            // edit le volume du clip (entre 0.0 et 1.0)
                            double gain = 0.65;
                            float dB = (float) (Math.log(gain) / Math.log(10.0) * 20.0);// convertie en decibel le double
                            gainControl.setValue(dB);//modifie le volume
                            gainControl2.setValue(dB);//modifie le volume
                            clip.start(); //lance le fichier audio
                            clip2.start(); //lance le fichier audio
                            JOptionPane.showMessageDialog(fenetre, "Victoire !!! WOW !!! vous avez coulé le dernier navire !!! ", "Resultat", JOptionPane.PLAIN_MESSAGE); //affiche un pop up
                            clip.stop();// stop les musique
                            clip2.stop();// stop les musique
                        } catch (UnsupportedAudioFileException unsupportedAudioFileException) {
                            unsupportedAudioFileException.printStackTrace();
                        } catch (LineUnavailableException lineUnavailableException) {
                            lineUnavailableException.printStackTrace();
                        } catch (IOException ioException) {
                            ioException.printStackTrace();
                        }
                    }else{
                        JOptionPane.showMessageDialog(fenetre, "Victoire! WOW !! Vous avez coulé le dernier navire ! ", "Victoire", JOptionPane.INFORMATION_MESSAGE); //affiche un pop up
                    }
                    //ferme la page et renvoie sur celle du créer flotte et rejoindre partie:
                    fenetrePlateau.dispose();// ferme cette fenêtre
                    Plateau plateauPers = new Plateau();//créer le plateau pour placer sa flotte
                    Fenetre placerBateau = new Fenetre(plateauPers);//créer la fenêtre de start
                    NavyFleet navyFleet = new NavyFleet();//créer la flotte (est vide)
                    placerBateau.FixedListenerCommencerUnPartie(new StartPartie(placerBateau,navyFleet));//Listener bouton créer
                    placerBateau.FixedListenerRejoindreUnePartie(new RejoindrePartie(placerBateau,navyFleet));//Listener bouton rejoindre
                    placerBateau.fixeListenerAjoutBateau(new ControleurPlacerBateauSelectionne(placerBateau,navyFleet)); //Listener ajouter placement bateau
                    placerBateau.fixeListenerRemplissageCategorie(new ControleurListeAjoutBateau(placerBateau, navyFleet)); //Ajouter bateaux en fonction du mode de jeu
                    placerBateau.pack();//permet de faire prendre au éléments leurs preffered size
                    placerBateau.setEnableRejoindre(false);
                    placerBateau.setEnableCreer(false);
                    placerBateau.setVisible(true);// active la fenetre(permet de l'afficher)

                }
            }
        //les exceptions se lèvent lors de problèmes rencontrés :
        } catch (BadCoordException | UnirestException badCoordException) {
            badCoordException.printStackTrace();
        } catch (Exception exception) {
            exception.printStackTrace();
        }
        //toi qui lis cela, tu es très beau (ou belle) !!!!
    }
}
