package controleurs;

import com.mashape.unirest.http.exceptions.UnirestException;
import info1.network.BadIdException;
import info1.network.Network;
import info1.ships.BadCoordException;
import info1.ships.INavyFleet;
import info1.ships.UncompleteFleetException;
import vue.Fenetre;
import vue.FenetrePlateau;

import javax.sound.sampled.*;
import javax.swing.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.IOException;

public class RejoindrePartie implements ActionListener {

    private Fenetre feneDebut;
    private INavyFleet flotte1;

    public RejoindrePartie(Fenetre fenetre, INavyFleet flotte){
        this.feneDebut = fenetre;
        this.flotte1=flotte;
    }

    public static final String HTTP_LOCALHOST = "http://37.187.38.219/api/v0";

    @Override
    public void actionPerformed(ActionEvent e) {
        try {
                feneDebut.chargerConnexion(feneDebut.getNouvellesParties());
                boolean res = Network.joinGame(HTTP_LOCALHOST, Fenetre.getValJComboBox(), feneDebut.getJoueur1(), flotte1);    //Permet de rejoindre une partie initialisée sur le serveur
                feneDebut.setGame(feneDebut.getValJComboBox());             //Récupère la partie sélectionné dans la JComboBox des parties, puis ça "set" la partie sur la fenetre avec la partie récupéré précédemment.
                //-----------------------------Capture des Exception-----------------------------///
                if (feneDebut.getPc() != true) {                                                 //Test si l'ordinateur n'est pas un PC de l'IUT pour ajouter les musiques.
                    try {
                        File file = new File("./Media/Sound/duel.wav");//recup le fichier audio
                        AudioInputStream audioStream = AudioSystem.getAudioInputStream(file);//convertie le fichier fichier en audio utilisable par la classe clip
                        Clip clip = AudioSystem.getClip();//Attribue le fichier audio
                        clip.open(audioStream);//ajoute a la liste de lecture
                        FloatControl gainControl = (FloatControl) clip.getControl(FloatControl.Type.MASTER_GAIN);// recup le volume du clip
                        // edit le volume du clip (entre 0.0 et 1.0)
                        double gain = 0.65;
                        float dB = (float) (Math.log(gain) / Math.log(10.0) * 20.0);// convertie en decibel le double
                        gainControl.setValue(dB);//modifie le volume
                        clip.start(); //lance le fichier audio
                    }   //-----------------------------Capture des Exception-----------------------------///
                    catch (UnsupportedAudioFileException unsupportedAudioFileException) {
                        unsupportedAudioFileException.printStackTrace();
                    } catch (LineUnavailableException lineUnavailableException) {
                        lineUnavailableException.printStackTrace();
                    } catch (IOException ioException) {
                        ioException.printStackTrace();
                    }
                }


                FenetrePlateau fenetreJeu = null;  //Initialisation du plateau de jeu
                try {
                    fenetreJeu = new FenetrePlateau(feneDebut.getPlateauPers(), feneDebut, false);        //Création du plateau du jeu
                }  //-----------------------------Capture des Exception-----------------------------///
                catch (UnirestException unirestException) {
                    unirestException.printStackTrace();
                } catch (BadIdException badIdException) {
                    badIdException.printStackTrace();
                }

                //----------------------------Ajout des FixedListener------------------------------
                //Fixe les listeners ici, car la fenetre est appelé dans le listener
                fenetreJeu.fixeListenerBouttonPlateauDroite(new ControleurPlateauDroite(fenetreJeu, feneDebut, feneDebut.getPc()));
                fenetreJeu.fixeListenerBoutonInfo(new ControleurBoutonRegle(fenetreJeu));
                fenetreJeu.fixeListenerBoutonMenu(new ControleurBoutonQuitter(fenetreJeu));
                //----------------------------Paramètre de la fenetre-------------------------------
                fenetreJeu.pack();
                fenetreJeu.setVisible(true); //On rend la fenetre de jeu visible
                feneDebut.dispose(); //On cache la fenetre du menu
                feneDebut.afficheRegle(); //Affichage de la fenêtre de règles avant le lancement de la partie

        }
        catch(UnirestException unirestException){

        } catch(UncompleteFleetException uncompleteFleetException){

        } catch(BadCoordException badCoordException){

        }
    }
}
