package controleurs;

import com.mashape.unirest.http.exceptions.UnirestException;
import info1.network.BadIdException;
import info1.network.Game;
import info1.network.Network;
import info1.ships.BadCoordException;
import info1.ships.INavyFleet;
import info1.ships.UncompleteFleetException;
import vue.Fenetre;
import vue.FenetrePlateau;

import javax.sound.sampled.*;
import javax.swing.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.IOException;


public class StartPartie implements ActionListener {

    private Fenetre feneDebut;
    private Game partie;
    private INavyFleet flotte1;
    public static final String HTTP_LOCALHOST = "http://37.187.38.219/api/v0";

    public StartPartie(Fenetre fenetre, INavyFleet flotte){
        this.feneDebut = fenetre;
        this.flotte1= flotte;
    }

    @Override
    public void actionPerformed(ActionEvent e) {
        //---Lancement de la partie dans le réseau
        try {
            if(flotte1.equals(null)){
                JOptionPane.showMessageDialog(feneDebut, "Vous n'avez pas de flotte ou Partie non trouver", "Resultat", JOptionPane.PLAIN_MESSAGE); //affiche un pop up
            }else {
                feneDebut.setFlotte(flotte1);                   //Récupération de la nouvelle flotte défini
                this.partie = Network.initNewGame(HTTP_LOCALHOST, feneDebut.getJoueur1(), feneDebut.getFlotte1());      //Initialiser la partie

                int result;
                result = Network.getInfo(HTTP_LOCALHOST, partie, feneDebut.getJoueur1());        //Récupère l'état de la partie
                System.out.println(result);                                                     //Affichage du résultat
                Game laPartie = this.partie;
                feneDebut.setGame(laPartie);                                                    //Récupère la partie créé pour la définir comme la partie courante

                if (feneDebut.getPc() != true) {                                                 //Test si l'ordinateur n'est pas un PC de l'IUT pour ajouter les musiques.
                    try {
                        File file = new File("./Media/Sound/duel.wav");//recup le fichier audio
                        AudioInputStream audioStream = AudioSystem.getAudioInputStream(file);//convertie le fichier fichier en audio utilisable par la classe clip
                        Clip clip = AudioSystem.getClip();//Attribue le fichier audio
                        clip.open(audioStream);//ajoute a la liste de lecture
                        FloatControl gainControl = (FloatControl) clip.getControl(FloatControl.Type.MASTER_GAIN);// recup le volume du clip
                        // edit le volume du clip (entre 0.0 et 1.0)
                        double gain = 0.65;
                        float dB = (float) (Math.log(gain) / Math.log(10.0) * 20.0);// convertie en decibel le double
                        gainControl.setValue(dB);//modifie le volume
                        clip.start(); //lance le fichier audio
                    }   //-----------------------------Capture des Exception-----------------------------///
                    catch (UnsupportedAudioFileException unsupportedAudioFileException) {
                        unsupportedAudioFileException.printStackTrace();
                    } catch (LineUnavailableException lineUnavailableException) {
                        lineUnavailableException.printStackTrace();
                    } catch (IOException ioException) {
                        ioException.printStackTrace();
                    }
                }

                //Initialisation de la fenetre de jeu, en récupérant le plateau complet créé dans le menu
                FenetrePlateau fenetreJeu = new FenetrePlateau(feneDebut.getPlateauPers(), feneDebut, true);

                //----------------------------Ajout des FixedListener------------------------------
                //Fixe les listeners ici, car la fenetre est appelé dans le listener
                fenetreJeu.fixeListenerBouttonPlateauDroite(new ControleurPlateauDroite(fenetreJeu, feneDebut, feneDebut.getPc()));
                fenetreJeu.fixeListenerBoutonInfo(new ControleurBoutonRegle(fenetreJeu));
                fenetreJeu.fixeListenerBoutonMenu(new ControleurBoutonQuitter(fenetreJeu));
                //----------------------------Paramètre de la fenetre-------------------------------
                fenetreJeu.pack();
                fenetreJeu.setVisible(true); //On rend la fenetre de jeu visible
                feneDebut.dispose(); //On cache la fenetre du menu
                feneDebut.afficheRegle(); //Affichage de la fenêtre de règles avant le lancement de la partie
            }


        }  //-----------------------------Capture des Exceptions-----------------------------///
        catch (UnirestException unirestException) {
            unirestException.printStackTrace();
        } catch (UncompleteFleetException uncompleteFleetException) {
            uncompleteFleetException.printStackTrace();
        } catch (BadCoordException badCoordException) {
            badCoordException.printStackTrace();
        } catch (BadIdException badIdException) {
            badIdException.printStackTrace();
        }




    }
}
