/*
#################################
##                             ##
##      Lire le README !!      ##
##                             ##
#################################
*/

package vue;

import com.mashape.unirest.http.exceptions.UnirestException;
import info1.network.Game;
import info1.network.Network;
import info1.network.Player;
import info1.ships.INavyFleet;
import info1.ships.NavyFleet;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionListener;
import java.awt.event.ItemListener;
import java.awt.event.MouseListener;
import java.util.List;

public class Fenetre extends JFrame {
    private static boolean pcIut;
    private static JButton buttonCreer;
    private static Player joueur1;
    private static INavyFleet flotte1;
    private static final String HTTP_LOCALHOST = "http://37.187.38.219/api/v0";
    private static JComboBox modeDeJeu;
    public static Game laPartie;
    private Plateau plateauJoueur;
    private static JComboBox listePartie;



    private static List<Game> parties;
    private static JButton buttonRejoindre;
    private static boolean setprox=false;

    private JComboBox categorie;
    private JTextField zoneTexteFront;
    private JTextField zoneTexteBack;
    private JButton ajouter;
    private JButton refresh;

    //Cette fenêtre correspond au menu
    //La fenetre prend un plateau en paramètre afin de récupérer par la suite le plateau où les bateaux auront été placés
    public Fenetre(Plateau plateau) throws Exception{
        //vérifie le type de pc utiliser pour le proxy
        if(setprox==false) {
            JOptionPane d = new JOptionPane();
            int retour = d.showConfirmDialog(this, "Utilisez vous un PC de l'IUT ?", "Proxy config", JOptionPane.YES_NO_OPTION); // popup pour mettre ou pas le proxy
            if (retour == (-1)) {
                System.exit(0);
            }
            if (retour == 1) {
                pcIut = false;
                setprox=true;
            } else {
                pcIut = true;
                setprox=true;
            }
            //Initialisation d'un joueur et d'une flotte
            String s = (String)JOptionPane.showInputDialog(this, "Entrez votre nom de joueur :", "Choix du nom", JOptionPane.PLAIN_MESSAGE);//popup pour choisir le nom du joueur
            if((s != null) && (s.length()>0)){
                joueur1 = new Player(s);
            }else{
                System.exit(0);
            }
        }
        this.plateauJoueur = plateau;
        this.setTitle("Bataille navale");       //Ajoute un titre a la fenêtre
        ImageIcon icon = new ImageIcon("Media/img/icon.png");  //Importation de l'image
        this.setIconImage(icon.getImage());     //Définir l'icon de l'application du jeu



        flotte1 = new NavyFleet();
        setProxy(pcIut);
        setPlayer(joueur1);

        //-------------Conteneur principal------------//
        JPanel conteneurP = new JPanel();
        conteneurP.setLayout(new BorderLayout());
        conteneurP.setBackground(new Color(255,255,255,150));

        //-----Le background (Image de background d'un label) -> Conteneur principal est dans ce label-------//
        ImageIcon background = new ImageIcon("Media/img/military_background.jpg");
        JLabel pourleBackground =new JLabel();
        pourleBackground.setPreferredSize(new Dimension(900,650));
        pourleBackground.setLayout(new FlowLayout());
        pourleBackground.setIcon(background);
        pourleBackground.add(conteneurP);

        //Ajout de bordure au plateau du joueur
        plateauJoueur.setBorder(BorderFactory.createTitledBorder("Joueur"));
        plateauJoueur.setBackground(new Color(0,0,0,0));


        //----------------------------------------DEBUT-Espace au milieu----------------------------------------------//
        //Création d'un JPanel panelEspace
        JPanel panelEspace = new JPanel();
        panelEspace.setLayout(new BoxLayout(panelEspace,BoxLayout.Y_AXIS));
        panelEspace.setPreferredSize(new Dimension(200,200));
        panelEspace.setBorder(BorderFactory.createEmptyBorder(25,20,0,0));
        panelEspace.setBackground(new Color(0,0,0,0));

        //Création  d'un JLabel espace, qui accompagne la JComboBox permettant de sélectionner le mode de jeu (Belge ou Fr)
        JLabel espace = new JLabel(" Mode de jeu :");
        espace.setBorder(BorderFactory.createEmptyBorder(0,0,5,0));

        //Espace permettant de gérer le placement
        JLabel vide = new JLabel(" ");

        //Création de la JComboBox permettant de sélectionner le mode de jeu
        modeDeJeu = new JComboBox();
        modeDeJeu.addItem("Français");
        modeDeJeu.addItem("Belge");
        modeDeJeu.setMaximumSize(new Dimension(100,20));
        modeDeJeu.setAlignmentX(LEFT_ALIGNMENT);

        //Création du bouton pour créer une partie, accompagné d'un JLabel
        JLabel creerpartie = new JLabel(" Créer une partie :");
        creerpartie.setBorder(BorderFactory.createEmptyBorder(35,0,5,0));
        buttonCreer = new JButton("Créer");
        buttonCreer.setEnabled(false); //On désactive le bouton par défaut, il s'active quand toute la flotte est placée

        //Création d'un JPanel pour la partie "Rejoindre", contenant les éléments permettant de rejoindre une partie
        JPanel rejoindre = new JPanel();
        rejoindre.setLayout(new BorderLayout());
        rejoindre.setAlignmentX(LEFT_ALIGNMENT);
        rejoindre.setMaximumSize(new Dimension(110,30));
        rejoindre.setBackground(new Color(0,0,0,0));

        //JLabel accompagné du bouton permettant de rejoindre une partie
        JLabel rejoindrepartie = new JLabel(" Rejoindre une partie :");
        rejoindrepartie.setBorder(BorderFactory.createEmptyBorder(35,0,5,0));

        //Recherche des parties existantes sur le serveur
        parties = Network.listInitializedGames(HTTP_LOCALHOST);


        //Appel de la méthode pour charger les connexions, permet de remplir la JComboBox indiquant les parties qu'il est possible de rejoindre
        listePartie = new JComboBox(chargerConnexion(parties));
        listePartie.setBorder(BorderFactory.createEmptyBorder(0,0,0,15));

        //Création d'un bouton permettant de rafraichir la liste des parties disponibles
        refresh = new JButton(new ImageIcon("Media/icon/reload.png"));
        refresh.setPreferredSize(new Dimension(25,25));

        //Ajout des éléments au panneau rejoindre
        rejoindre.add(listePartie,BorderLayout.WEST);
        rejoindre.add(refresh);

        //Bouton rejoindre qui s'active ou fois la flotte complete
        buttonRejoindre = new JButton("Rejoindre");
        buttonRejoindre.setEnabled(false); //On désactive le bouton par défaut, il s'active quand toute la flotte est placée

        //Ajout des éléments au panelEspace
        panelEspace.add(espace);
        panelEspace.add(vide);
        panelEspace.add(modeDeJeu);
        panelEspace.add(creerpartie);
        panelEspace.add(buttonCreer);
        panelEspace.add(rejoindrepartie);
        panelEspace.add(rejoindre);
        panelEspace.add(vide);
        panelEspace.add(buttonRejoindre);
        //---------------------------------------------FIN-Espace au milieu-------------------------------------------//





        //---------------------------------------------DEBUT-JPanel Sud-----------------------------------------------//
        //Création des deux Jpanel
        JPanel  sud = new JPanel(new FlowLayout());
        JPanel sudGauche = new JPanel(new FlowLayout());
        sudGauche.setBackground(new Color(0,0,0,0));

        //Création de la JComboBox permettant de choisir quel bateau est à placer + JLabel associé
        JLabel labelCategorie = new JLabel("Ajout bateau :");
        labelCategorie.setSize(25,25);
        //Initialisation de la JComboBox avec par défaut la configuration Française
        String[] bateauxFr = {"Cuirassé (4 cases)","Croiseur (3 cases)","Croiseur (3 cases)","Torpilleur (2 cases)", "Torpilleur (2 cases)", "Sous-marin (1 case)", "Porte-avion (5 cases)" };
        categorie = new JComboBox(bateauxFr);

        //Création des champs de texte permettant de remplir les coordonnées d'un bateau à placer
        //Coordonnées de l'avant du bateau :
        JLabel labelFront = new JLabel("Coord Front :");
        zoneTexteFront = new JTextField("");
        zoneTexteFront.setColumns(15);
        //Coordonnées de l'arrière du bateau
        JLabel labelBack = new JLabel("Coord Back :");
        zoneTexteBack = new JTextField("");
        zoneTexteBack.setColumns(15);
        zoneTexteBack.setSize(50,25);

        //Création du bouton de validation permettant d'ajouter le bateau
        ajouter = new JButton("+");


        //-----------------------------DEBUT-Ajout des éléments au JPanel sud-----------------------------------------//
        sudGauche.add(labelCategorie);
        sudGauche.add(categorie);
        sudGauche.add(labelFront);
        sudGauche.add(zoneTexteFront);
        sudGauche.add(labelBack);
        sudGauche.add(zoneTexteBack);
        sudGauche.add(ajouter);
        sud.add(sudGauche);
        //-----------------------------FIN-Ajout des éléments au JPanel Sud-------------------------------------------//
        //-----------------------------------------------FIN-JPanel Sud-----------------------------------------------//




        //-----------------------------DEBUT-Ajout des éléments au conteneur principal--------------------------------//
        conteneurP.add(plateauJoueur, BorderLayout.WEST);
        conteneurP.add(sudGauche, BorderLayout.SOUTH);
        conteneurP.add(panelEspace, BorderLayout.CENTER);
        //-------------------------------FIN-Ajout des éléments au conteneur principal--------------------------------//


        //----------------------------------------DEBUT-Initialisation de la fenêtre----------------------------------//
        this.add(pourleBackground);
        this.setSize(1200, 1000);
        this.setLocationRelativeTo(null);
        this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        this.setVisible(true);
        this.setResizable(false);
        this.pack();
        //-----------------------------------------FIN-Initialisation de la fenêtre-----------------------------------//

    }

    //---------------Les méthodes pour le code----------------//
    //Récupérer la valeur sélectionné dans la JComboBox des liste de parties à rejoindre
    public static Game getValJComboBox(){
        Object obj = listePartie.getSelectedItem();
        String res = String.valueOf(obj);
        //String res = (String) listePartie.getSelectedItem();
        for (int i=0;i<parties.size();i++){
            if(res.equals(String.valueOf(parties.get(i).getId()))){
                return parties.get(i);
            }
        }
        return parties.get(-1);
    }
    //Charger les connexions disponibles à rejoindre
    public String[] chargerConnexion(List<Game> partiesNv){
        String[] partiesString = new String[partiesNv.size()];
        for(int i=0; i < partiesNv.size();i++){
            partiesString[i]= String.valueOf(partiesNv.get(i).getId());
        }
        return partiesString;
    }
    //Remplissage catégorie
    public String getChoixModeDeJeu(){ //Sert à récupérer le mode de jeu sélectionné
        String retour = (String)modeDeJeu.getSelectedItem();
        return retour;
    }

    //-----------------GETTERS------------------
    public String getCoordFront(){
        return zoneTexteFront.getText();
    }
    public String getCoordBack(){
        return zoneTexteBack.getText();
    }
    public Plateau getPlateauPers(){
        return plateauJoueur;
    }
    public String getCategorieBateauAPlacer(){
        return (String) categorie.getSelectedItem();
    }
    public List<Game> getNouvellesParties() throws UnirestException {
        return Network.listInitializedGames(HTTP_LOCALHOST);
    }
    public Player getJoueur1(){
        return this.joueur1;
    }
    public INavyFleet getFlotte1() {
        return flotte1;
    }
    public static Game getGame(){
        return laPartie;
    }
    public String getNetwork(){
        return HTTP_LOCALHOST;
    }
    public boolean getPc(){
        return this.pcIut;
    }
    public static List<Game> getParties() {
        return parties;
    }

    //------------------SETTERS---------------------
    public void setEnableChoixModeJeu(boolean b){
        modeDeJeu.setEnabled(b);
    }
    public void setEnableCreer(boolean b){
        buttonCreer.setEnabled(b);
    }
    public void setEnableRejoindre(boolean b){
        buttonRejoindre.setEnabled(b);
    }
    public void setFlotte(INavyFleet flotte){
        this.flotte1=flotte;
    }
    public void setGame(Game partie){
        laPartie = partie;
    }


    //----------------METHODES---------------------
    //Rempli la JComboBox en fonction du mode de jeu (Belge ou Français)
    public void initBateauxEnFonctionModeJeu(String[] liste){
        this.categorie.removeAllItems();
        for(String s : liste){
            categorie.addItem(s);
        }
    }
    //Supprime le bateau de la JComboBox une fois qu'il est placé
    public void supprimerChoixBateauCourant() {
        DefaultComboBoxModel cmbModel = (DefaultComboBoxModel) categorie.getModel();
        cmbModel.removeElementAt(categorie.getSelectedIndex());
    }
    //Mise à jour de la liste des parties à rejoindre
    public void setListePartie(String[] listeDesConnexions){
        this.listePartie.removeAllItems();
        for(int i=0;i<listeDesConnexions.length;i++){
            this.listePartie.addItem(listeDesConnexions[i]);
        }
    }
    //Set le proxy sur true ou false selon le paramètre
    public void setProxy(boolean etat){
        Network.setProxy("srv-proxy-etu-2.iut-nantes.univ-nantes.prive", 3128);
        Network.enableProxy(etat);
    }
    //Subscribe le player en paramètre sur le serveur
    public void setPlayer(Player joueur){
        try {
            Network.suscribeNewPlayer(HTTP_LOCALHOST,joueur);
        } catch (UnirestException unirestException) {
            unirestException.printStackTrace();
            System.exit(0);
        }
    }

    //Affichage de la fenêtre de règles avant le lancement de la partie
    public void afficheRegle(){
        JFrame erreur = new JFrame();
        String message = "Ce jeu est simple !\n" +
                "Votre écran est à gauche, il affiche la disposition que vous avez choisi pour vos bateaux au menu précédent.\n" +
                "A droite se trouve la disposition de votre adversaire, cachée évidemment; chacun votre tour, vous allez tenter de couler\n" +
                "les bateaux ennemis. Il faut cliquer sur une case pour tirer ; si la case est vide, elle reste grisée. A l'inverse, si vous touchez \n" +
                "un bateau ennemi, la case restera marquée en rouge.Lorsqu'un bateau est coulé, la dernière case touchée s'affichera en bleu foncé !\n" +
                "Le gagnant sera le premier joueur qui réussira  à couler tous les navires adverses !";
        JOptionPane.showMessageDialog(erreur, message, "Règles du jeu", JOptionPane.INFORMATION_MESSAGE);
    }


    //--------------------FIXE LISTENERS---------------------------------
    public void fixeListenerRemplissageCategorie(ItemListener listener){            //Ajouter bateaux en fonction du mode de jeu
        modeDeJeu.addItemListener(listener);
    }
    public void fixeListenerAjoutBateau(ActionListener listener){                   //Listener ajouter placement bateau
        ajouter.addActionListener(listener);
    }
    public static void FixedListenerCommencerUnPartie(ActionListener action) {      //Listener qui fais créer une partie
        buttonCreer.addActionListener(action);
    }
    public static void FixedListenerRejoindreUnePartie(ActionListener action){      //Listener qui fais rejoindre une partie
        buttonRejoindre.addActionListener(action);
    }
    public void fixeListenerRepaintOnComboBox(ItemListener action, ActionListener action2, MouseListener action3){
        categorie.addItemListener(action);
        categorie.addActionListener(action2);
        modeDeJeu.addActionListener(action2);
        modeDeJeu.addItemListener(action);
        listePartie.addItemListener(action);
        listePartie.addActionListener(action2);

        this.addMouseListener(action3);
    }
    public void fixedListenerChargerPartie(ActionListener action){                  //Listener qui fais rafraichir la liste des connexions
        refresh.addActionListener(action);
    }
    //-------------------------------------------------------------------











}
