/*
#################################
##                             ##
##      Lire le README !!      ##
##                             ##
#################################
*/

package vue;

import com.mashape.unirest.http.exceptions.UnirestException;
import info1.network.BadIdException;
import info1.network.Network;


import javax.sound.sampled.*;
import javax.swing.*;
import javax.swing.border.Border;
import javax.swing.border.CompoundBorder;
import javax.swing.border.EmptyBorder;
import java.awt.*;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.IOException;

import static vue.Fenetre.getGame;

public class FenetrePlateau extends JFrame {

    private JButton info;
    private JButton retourMenu;
    private JLabel numroLobby;
    private Plateau plateauJoueur;
    private PlateauBoutons plateauAdversaire;
    private boolean partiecourante;
    public static JLabel etatTour; //Savoir si c'est notre tour


    //FenetrePlateau est la fenêtre de jeu où l'on retrouve à gauche un plateau qui correspond à celui initialisé dans la fenetre menu et à droite le plateau adverse
    public FenetrePlateau(Plateau plateau, Fenetre fenetre, boolean bool) throws UnirestException, BadIdException { //On prend un plateau en paramètre afin de pouvoir récupérer le plateau du menu
        if(fenetre.getPc() != true) {                                                 //Test si l'ordinateur n'est pas un PC de l'IUT pour ajouter les musiques.
            try {
                File file = new File("./Media/Sound/themeSong.wav");//recup le fichier audio
                AudioInputStream audioStream = AudioSystem.getAudioInputStream(file);//convertie le fichier fichier en audio utilisable par la classe clip
                Clip clip = AudioSystem.getClip();//Attribue le fichier audio
                clip.open(audioStream);//ajoute a la liste de lecture
                FloatControl gainControl = (FloatControl) clip.getControl(FloatControl.Type.MASTER_GAIN);// recup le volume du clip
                // edit le volume du clip (entre 0.0 et 1.0)
                double gain = 0.10;
                float dB = (float) (Math.log(gain) / Math.log(10.0) * 20.0);// convertie en decibel le double
                gainControl.setValue(dB);//modifie le volume
                clip.loop(1000); //lance le fichier audio
            }   //-----------------------------Capture des Exception-----------------------------///
            catch (UnsupportedAudioFileException unsupportedAudioFileException) {
                unsupportedAudioFileException.printStackTrace();
            } catch (LineUnavailableException lineUnavailableException) {
                lineUnavailableException.printStackTrace();
            } catch (IOException ioException) {
                ioException.printStackTrace();
            }
        }
        this.plateauJoueur = plateau;
        this.partiecourante = bool;
        this.setTitle("Bataille navale");
        ImageIcon icon = new ImageIcon("Media/img/icon.png");
        this.setIconImage(icon.getImage());
        //Conteneur principal
        JPanel conteneurP = new JPanel();
        conteneurP.setLayout(new BorderLayout());
        conteneurP.setBackground(new Color(255,255,255,150));

        //-----Le background (Image de background d'un label) -> Conteneur principal est dans ce label-------//
        ImageIcon background = new ImageIcon("Media/img/military_background.jpg");
        JLabel pourleBackground =new JLabel();
        pourleBackground.setPreferredSize(new Dimension(1450,700));
        pourleBackground.setLayout(new FlowLayout());
        pourleBackground.setIcon(background);
        pourleBackground.add(conteneurP);

        //Ajout de bordure au plateau joueur (gauche)
        plateauJoueur.setBorder(BorderFactory.createTitledBorder("Mon plateau"));
        
        //Espace au milieu contenant des boutons et séparant les deux plateaux
        JPanel panelEspace = new JPanel();
        //panelEspace.setLayout(new BoxLayout(panelEspace,BoxLayout.Y_AXIS));
        panelEspace.setLayout(new FlowLayout(FlowLayout.CENTER));
        panelEspace.setPreferredSize(new Dimension(165, 200));
        panelEspace.setBackground(new Color(0,0,0,0));

        //Affichage du nom du lobby dans lequel on est présent
        if(partiecourante){
            numroLobby = new JLabel("ID Partie : " + String.valueOf(getGame().getId()));
        }else {
            numroLobby= new JLabel(("ID Partie : "+fenetre.getValJComboBox().getId()));
        }

        //numroLobby = new JLabel("ID Partie : " + String.valueOf(Fenetre.getGame().getId()));
        numroLobby.setVerticalTextPosition(SwingConstants.CENTER);
        numroLobby.setHorizontalTextPosition(SwingConstants.CENTER);
        numroLobby.setAlignmentY(Component.CENTER_ALIGNMENT);
        numroLobby.setBorder(BorderFactory.createLineBorder(Color.BLACK));
        Border border = numroLobby.getBorder();                             //Recuperation de la border dans une variable de type Border
        Border margin = new EmptyBorder(2,2,2,2);      //Creation de la marge
        numroLobby.setBorder(new CompoundBorder(border, margin));//Configuration de la border avec le margin
        numroLobby.setPreferredSize(new Dimension(130,20));


        //Bouton info, donnant les règles du jeu lorsque l'on clique dessus
        info = new JButton("Règle du jeu");
        info.setVerticalTextPosition(SwingConstants.CENTER);
        info.setHorizontalTextPosition(SwingConstants.CENTER);
        info.setAlignmentY(Component.CENTER_ALIGNMENT);



        //Label etatTour, permettant de savoir si c'est à notre tour de jouer
        //Thread majTour = new Thread();
        //majTour.run();
        etatTour = new JLabel();
        etatTour.setVerticalTextPosition(SwingConstants.CENTER);
        etatTour.setHorizontalTextPosition(SwingConstants.CENTER);
        etatTour.setAlignmentY(Component.CENTER_ALIGNMENT);
        etatTour.setBorder(BorderFactory.createLineBorder(Color.BLACK));
        Border border2 = numroLobby.getBorder();                             //Recuperation de la border dans une variable de type Border
        Border margin2 = new EmptyBorder(2,2,2,2);      //Creation de la marge
        etatTour.setBorder(new CompoundBorder(border2, margin2));
        etatTour.setPreferredSize(new Dimension(160,20));
        etatTour.setText("Etat de la partie :");



        //Bouton menu, permettant de quitter la partie et de revenir au menu
        retourMenu = new JButton("Quitter");
        retourMenu.setVerticalTextPosition(SwingConstants.CENTER);
        retourMenu.setHorizontalTextPosition(SwingConstants.CENTER);
        retourMenu.setAlignmentY(Component.CENTER_ALIGNMENT);



        //Ajout des éléments au panneau du milieu
        panelEspace.add(Box.createRigidArea(new Dimension(0, 200))); //Cette instruction permet de placer un bloc invisible et donc d'aider à positionner nos boutons où nous le souhaitons
        panelEspace.add(numroLobby);
        panelEspace.add(etatTour);
        panelEspace.add(Box.createRigidArea(new Dimension(0, 200))); //Cette instruction permet de placer un bloc invisible et donc d'aider à positionner nos boutons où nous le souhaitons
        panelEspace.add(info);
        panelEspace.add(Box.createRigidArea(new Dimension(0, 200))); //Cette instruction permet de placer un bloc invisible et donc d'aider à positionner nos boutons où nous le souhaitons
        panelEspace.add(retourMenu);
        panelEspace.add(etatTour);

        //Création du Plateau adversaire (cliquable)
        plateauAdversaire = new PlateauBoutons();
        plateauAdversaire.setBorder(BorderFactory.createTitledBorder("Adversaire"));
        plateauAdversaire.setBackground(new Color(0,0,0,0));


        //--------------Ajout des éléments au conteneur principal---------------//
        conteneurP.add(plateauJoueur, BorderLayout.WEST);
        conteneurP.add(panelEspace, BorderLayout.CENTER);
        conteneurP.add(plateauAdversaire, BorderLayout.EAST);
        //--------------Ajout des éléments au conteneur principal---------------//

        //Initialisation de la fenêtre de jeu
        this.add(pourleBackground);
        this.setSize(1750, 1000);
        this.setPreferredSize(new Dimension(1400, 650));
        this.setLocationRelativeTo(null);
        this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        this.setVisible(true);
        this.setResizable(false);
        this.pack();

        ThreadTourJeu aToiDeJouer = new ThreadTourJeu("aToiDeJouer",this,fenetre);
        aToiDeJouer.start();


    }
    //------------------------METHODES-------------------------------------------//


    //------------------------GETTERS--------------------------------------------//
    public PlateauBoutons getPlateauAdversaire(){
        return plateauAdversaire;
    }

    //------------------------SETTERS--------------------------------------------//
    public void setEtatTour(String s){
        etatTour.setText(s);

    }

    //----------------------FIXE LISTENERS--------------------------------------//
    public void fixeListenerBouttonPlateauDroite(ActionListener listener){
        plateauAdversaire.fixeListenerBouttonPlateauDroite(listener);
    }
    public void fixeListenerBoutonInfo(ActionListener listener){
        info.addActionListener(listener);
    }
    public void fixeListenerBoutonMenu(ActionListener listener){
        retourMenu.addActionListener(listener);
    }




}
