/*
#################################
##                             ##
##      Lire le README !!      ##
##                             ##
#################################
*/

package vue;

import javax.swing.*;
import java.awt.*;
import java.util.ArrayList;

public class Plateau extends JPanel {
    /*
    Cette classe a pour but de de décomposer la vue en plusieurs parties, dont le plateau.
    Le plateau est composé de Case, qui permettent de facilement retrouver les coordonnées voulues.
     */

    protected Case grilleCases[][]; //Sert à stocker les différents exemplaires de Case


    public Plateau(){
        setPreferredSize(new Dimension(600, 600)); //Dimension d'un plateau
        setLayout(new BorderLayout());

        //---------PANNEAU NORTH - Légende (lettres)-----------
        JPanel panelLettres = new JPanel();
        panelLettres.setLayout(new GridLayout(1, 10));

        panelLettres.setBackground(new Color(0,0,0,0));

        //Boucle permettant de remplir la légende
        for(int i = 0; i < 10; i++){
            JLabel labelLettre = new JLabel();
            labelLettre.setText(String.valueOf((char)('A'+i))); //La lettre est ajouté à chaque tour de boucle, on passe de A -> B -> C etc
            labelLettre.setVerticalAlignment(JLabel.CENTER);
            labelLettre.setHorizontalAlignment(JLabel.CENTER);
            panelLettres.add(labelLettre);
        }

        //---------PANNEAU WEST - Légende (chiffres)-----------
        JPanel pannelChiffres = new JPanel();
        pannelChiffres.setLayout(new GridLayout(10, 1));
        pannelChiffres.setBackground(new Color(0,0,0,0));

        //Boucle permettant de remplir la légende
        for(int i = 1; i <= 10; i++){
            JLabel labelChiffres = new JLabel();
            labelChiffres.setText(String.valueOf(i));
            labelChiffres.setVerticalAlignment(JLabel.CENTER);
            labelChiffres.setHorizontalAlignment(JLabel.HORIZONTAL);
            pannelChiffres.add(labelChiffres);
        }


        //----------PANNEAU CENTER---------------------------
        JPanel panneauJeu = new JPanel(); //JPanel faisant office de plateau de jeu (grilles de 10 x 10)
        panneauJeu.setLayout(new GridLayout(10, 10)); //GridLayout de 10 x 10

        grilleCases = new Case[10][10]; //Initialisation de la matrice de cases

        //Création matrice grilleCases
        for(int i = 0; i < grilleCases.length; i++){
            grilleCases[i] = new Case[10];
        }

        //Remplissage matrice
        for(int i = 0; i < grilleCases.length; i++){
            for(int j = 0; j < grilleCases[i].length; j++){
                Case test = new Case(i+1, j+1); //Création d'une nouvelle case à chaque tour de boucle
                grilleCases[i][j] = test; //Ajout de la case à la matrice
                panneauJeu.add(test); //Ajout de la case à la grille de jeu
            }
        }

        panneauJeu.setBorder(BorderFactory.createBevelBorder(1));
        panneauJeu.setBackground(new Color(6,66,115));

        this.add(panneauJeu, BorderLayout.CENTER);
        this.add(panelLettres, BorderLayout.NORTH);
        this.add(pannelChiffres, BorderLayout.WEST);
    }

    //Méthode permettant de récupérer une case à partir de coordonnées
    public Case getCase(int x, int y){
        return this.grilleCases[x][y];
    }
}
