/*
#################################
##                             ##
##      Lire le README !!      ##
##                             ##
#################################
*/

package vue;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionListener;
import java.util.ArrayList;

        /*
       La classe PlateauBoutons fonctionne de la même manière que la classe Plateau, sauf que la surface de jeu est composée de
       CaseBouton. C'est le plateau de l'adversaire.
       Il utilise aussi une ArrayList listeBoutons qui nous est utile pour savoir quel bouton a été cliqué dans le listener associé
       */

public class PlateauBoutons extends JPanel{

    private CaseBouton grilleCases[][];
    public ArrayList listeBoutons;

    public PlateauBoutons(){
        listeBoutons = new ArrayList<CaseBouton>();

        setPreferredSize(new Dimension(600, 600));
        setLayout(new BorderLayout());

        //PANNEAU NORTH
        JPanel panelLettres = new JPanel();
        panelLettres.setLayout(new GridLayout(1, 10));
        for(int i = 0; i < 10; i++){
            JLabel labelLettre = new JLabel();
            labelLettre.setText(String.valueOf((char)('A'+i)));
            labelLettre.setVerticalAlignment(JLabel.CENTER);
            labelLettre.setHorizontalAlignment(JLabel.CENTER);
            panelLettres.add(labelLettre);
        }
        panelLettres.setBackground(new Color(0,0,0,0));


        //PANNEAU WEST
        JPanel pannelChiffres = new JPanel();
        pannelChiffres.setLayout(new GridLayout(10, 1));
        for(int i = 1; i <= 10; i++){
            JLabel labelChiffres = new JLabel();
            labelChiffres.setText(String.valueOf(i));
            labelChiffres.setVerticalAlignment(JLabel.CENTER);
            labelChiffres.setHorizontalAlignment(JLabel.HORIZONTAL);
            pannelChiffres.add(labelChiffres);
        }
        pannelChiffres.setBackground(new Color(0,0,0,0));

        //PANNEAU CENTER
        JPanel panneauJeu = new JPanel();
        panneauJeu.setLayout(new GridLayout(10, 10));

        grilleCases = new CaseBouton[10][10];

        //Création matrice grilleCases
        for(int i = 0; i < grilleCases.length; i++){
            grilleCases[i] = new CaseBouton[10];
        }

        //Remplissage matrice
        for(int i = 0; i < grilleCases.length; i++){
            for(int j = 0; j < grilleCases[i].length; j++){
                CaseBouton test = new CaseBouton(i+1, j+1);
                grilleCases[i][j] = test;
                panneauJeu.add(test);
                listeBoutons.add(test);
            }
        }

        panneauJeu.setBorder(BorderFactory.createBevelBorder(1));
        panneauJeu.setBackground(new Color(6,66,115));

        this.add(panneauJeu, BorderLayout.CENTER);
        this.add(panelLettres, BorderLayout.NORTH);
        this.add(pannelChiffres, BorderLayout.WEST);


    }


    //--------------------Fixe Listeners----------------------------------//
    public void fixeListenerBouttonPlateauDroite(ActionListener listener){
        for(int i = 0; i < grilleCases.length; i++){
            for(int j = 0; j < grilleCases[i].length; j++){
               grilleCases[i][j].addActionListener(listener);

            }
        }
    }

    //------------------Getters--------------------------------------------//
    public ArrayList getListeCasesBoutons(){
        return this.listeBoutons;
    }





}
