package vue;

import com.mashape.unirest.http.exceptions.UnirestException;
import controleurs.ControleurListeAjoutBateau;
import controleurs.ControleurPlacerBateauSelectionne;
import controleurs.RejoindrePartie;
import controleurs.StartPartie;
import info1.network.BadIdException;
import info1.network.Network;
import info1.ships.NavyFleet;

import javax.sound.sampled.*;
import javax.swing.*;
import java.io.File;
import java.io.IOException;

public class ThreadTourJeu extends Thread {

    private FenetrePlateau fenetrePlateau;
    private Fenetre fenetre;
    private boolean running;

    public ThreadTourJeu(String name,FenetrePlateau fen, Fenetre fen2){
        super(name);
        this.fenetrePlateau = fen;
        this.fenetre = fen2;
        this.running = true;
    }

    public void run() {
        while (running){
            this.fenetrePlateau.repaint();
            try {
               int valServ = Network.getInfo(fenetre.getNetwork(), Fenetre.getGame(),fenetre.getJoueur1());
                if(valServ == (-9999)){
                    fenetrePlateau.setEtatTour("Erreur partie");
                    this.arret();
                }else if(valServ == (-100)){
                    fenetrePlateau.setEtatTour("Partie perdue");
                    this.fenetrePlateau.repaint();
                    if(fenetre.getPc() != true) {
                        try {//audio de défaite
                            File file = new File("./Media/Sound/music_defaite.wav");//recup le fichier audio
                            File file2 = new File("./Media/Sound/parole_perdu2.wav");//recup le fichier audio
                            AudioInputStream audioStream = AudioSystem.getAudioInputStream(file);//convertie le fichier fichier en audio utilisable par la classe clip
                            AudioInputStream audioStream2 = AudioSystem.getAudioInputStream(file2);//convertie le fichier fichier en audio utilisable par la classe clip
                            Clip clip = AudioSystem.getClip();//Attribue le fichier audio
                            Clip clip2 = AudioSystem.getClip();//Attribue le fichier audio
                            clip.open(audioStream);//ajoute a la liste de lecture
                            clip2.open((audioStream2));//ajoute a la liste de lecture
                            FloatControl gainControl = (FloatControl) clip.getControl(FloatControl.Type.MASTER_GAIN);// recup le volume du clip
                            FloatControl gainControl2 = (FloatControl) clip2.getControl(FloatControl.Type.MASTER_GAIN);// recup le volume du clip
                            // edit le volume du clip (entre 0.0 et 1.0)
                            double gain = 0.45;
                            float dB = (float) (Math.log(gain) / Math.log(10.0) * 20.0);// convertie en decibel le double
                            gainControl.setValue(dB);//modifie le volume
                            gainControl2.setValue(dB);//modifie le volume
                            clip.start(); //lance le fichier audio
                            clip2.start(); //lance le fichier audio
                            JOptionPane.showMessageDialog(fenetre, "Perdu ! Tu es mauvais Jack !", "Resultat", JOptionPane.PLAIN_MESSAGE); //affiche un pop up
                            clip.stop();
                            clip2.stop();
                        } catch (UnsupportedAudioFileException unsupportedAudioFileException) {
                            unsupportedAudioFileException.printStackTrace();
                        } catch (LineUnavailableException lineUnavailableException) {
                            lineUnavailableException.printStackTrace();
                        } catch (IOException ioException) {
                            ioException.printStackTrace();
                        }
                    }else{
                        JOptionPane.showMessageDialog(fenetre, "Perdu ! Tu es mauvais Jack !", "Résultat", JOptionPane.PLAIN_MESSAGE); //affiche un pop up
                    }
                    //ferme la page et renvoie sur celle du créer flotte et rejoindre/créer une partie:
                    fenetrePlateau.dispose();// ferme cette fenêtre
                    Plateau plateauPers = new Plateau(); //créer le plateau pour placer sa flotte
                    Fenetre placerBateau = new Fenetre(plateauPers);//créer la fenêtre de start
                    NavyFleet navyFleet = new NavyFleet();//créer la flotte (est vide)
                    placerBateau.FixedListenerCommencerUnPartie(new StartPartie(placerBateau,navyFleet));//Listener bouton créer
                    placerBateau.FixedListenerRejoindreUnePartie(new RejoindrePartie(placerBateau,navyFleet)); //Listener bouton rejoindre
                    placerBateau.fixeListenerAjoutBateau(new ControleurPlacerBateauSelectionne(placerBateau,navyFleet)); //Listener ajouter placement bateau
                    placerBateau.fixeListenerRemplissageCategorie(new ControleurListeAjoutBateau(placerBateau, navyFleet)); //Ajouter bateaux en fonction du mode de jeu
                    placerBateau.pack();//permet de faire prendre au éléments leurs preffered size
                    placerBateau.setVisible(true);// active la fenetre(permet de l'afficher)
                    this.arret();
                }else if(valServ == (100)){
                    fenetrePlateau.setEtatTour("Partie gagnée");
                    this.fenetrePlateau.repaint();
                    this.arret();
                }else{
                    if(valServ == 1){
                        fenetrePlateau.setEtatTour("Partie créée");
                    }
                    if(valServ == (-1)){
                        fenetrePlateau.setEtatTour("Partie rejointe");
                    }
                    if(valServ == 10){
                        fenetrePlateau.setEtatTour("A vous de jouer !");
                    }
                    if(valServ == (-10)){
                        fenetrePlateau.setEtatTour("L'adversaire joue");
                    }
                }
            } catch (UnirestException e) {
            } catch (BadIdException e) {
            } catch (Exception e) {
            }
        }
    }
    public void arret() { // Méthode 2
        running = false;
    }
}
